SystemOrganization addCategory: #Roassal2GT!
SystemOrganization addCategory: 'Roassal2GT-EventCollector'!
SystemOrganization addCategory: 'Roassal2GT-Examples'!
SystemOrganization addCategory: 'Roassal2GT-Glamour'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Actions'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Context'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Roassal-Interaction'!
SystemOrganization addCategory: 'Roassal2GT-Spotter'!
SystemOrganization addCategory: 'Roassal2GT-Tests-Examples'!

!GLMCompositePresentation methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 2/13/2014 07:06'!
roassal2
	^ self custom: GLMRoassal2Presentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassal2Renderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMMorphicRoassal2Renderer commentStamp: '' prior: 0!
A GLMMorphicRoassalRenderer is xxxxxxxxx.

Instance Variables
	myMorph:		<Object>

myMorph
	- xxxxx
!

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'SergeStinckwich 6/19/2014 23:25'!
actOnPresentationUpdate: ann
	| aView canvas |
	aView := ann presentation newViewBlock value.
	ann presentation renderOn: aView.
	canvas := aView view setUpCanvas.
	myMorph 
		canvas: canvas;
		extent: canvas extent.
		! !

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'AlexandreBergel 9/4/2015 18:38'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	^ myMorph := view view setUpCanvas buildMorph! !

!Object methodsFor: '*Roassal2GT-Spotter' stamp: 'AndreiChis 2/20/2016 11:48'!
spotterForRenderingShapesFor: aStep
	<spotterOrder: 5>
	(aStep hasPreviousNavigationFromClass: RTView) ifTrue: [ 
		aStep listProcessor
			title: 'Shapes';
			candidatesLimit: 5;
			allCandidates: [ aStep previousStep origin elements select: [ :each | each model = self ] ];
			itemName: [ :each | each gtDisplayString, ' [', each shape class name, ']' ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: true ]! !

GLMMorphicTest subclass: #GLMRoassal2MorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2MorphicTest commentStamp: '' prior: 0!
A GLMRoassalMorphicTest is xxxxxxxxx.
!

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testCanvas
	| composer roassalMorph |
	composer := GLMCompositePresentation new.
	composer roassal2 painting: [:view :input | view add: RTElement new].
	window := composer openOn: 42.

	roassalMorph := self find: TRMorph in: window.
	self assert: (roassalMorph isKindOf: TRMorph)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 3/20/2015 15:08'!
testMondrianViewBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 
					initializeView: [ RTMondrian new ];
					painting: [ :view | view nodes: (1 to: 42) ].
	window := composite openOn: 42.
	self assert: composite first view class = RTMondrian.
	self assert: composite first view view elements size = 42! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:08'!
testOpenTitled
	| v |
	v :=  RTBuilder new view.
	window := v openTitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:07'!
testOpenWithToolbarEntitled

	window := RTBuilder new openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:09'!
testOpenWithToolbarEntitled02

	| v |
	v := RTView new.
	
	window := v openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testRoassalPresentationConstructor
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	self assert: composite presentations size equals: 1.
	self assert: (composite presentations anyOne isKindOf: GLMRoassal2Presentation)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:53'!
testUpdateUsesNewView
	| browser originalView newView |
	browser := GLMWrapper new.
	browser show: [ :a | 
		a roassal2 painting: [:view :roassal2 :input | view add: RTElement new ]].
	window := browser openOn: $d.

	originalView := (self find: TRMorph in: window) trachelCanvas.
	browser panes first presentations first update.
	newView := (self find: TRMorph in: window) trachelCanvas.
	
	self assert: newView ~~ originalView
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 10/26/2014 23:35'!
testUpdateViewIsProperlyLaidOut
	| browser originalView newView |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | a roassal2 painting: [ :view :input | 
			view addAll: (RTBox elementsOn: ($a to: input)).
			RTHorizontalLineLayout on: view elements ] ].
	window := browser openOn: $d.
	originalView := browser panes first presentations first view.
	self assert: (originalView elements detect: [ :each | each model = $b ]) center x equals: 17.5.
	browser panes first presentations first update.
	newView := browser panes first presentations first view.
	self assert: (newView elements detect: [ :each | each model = $b ]) center x equals: 17.5! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/20/2015 07:30'!
testZoomingActionsWorkForMondrianBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 initializeView: RTMondrian new.
	window := composite openOn: 42.
	self assert: composite first actions notEmpty.
	"these are the zooming actions"
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.
	self shouldnt: (composite first actions third actOn: composite first) raise: Error
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/20/2015 07:30'!
testZoomingActionsWorkForView
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	window := composite openOn: 42.
	self assert: composite first actions notEmpty.
	"these are the zooming actions"
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.
	self shouldnt: (composite first actions third actOn: composite first) raise: Error
! !

!GLMMorphicRenderer methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 2/13/2014 07:13'!
renderRoassal2Presentation: aPresentation
	^ GLMMorphicRoassal2Renderer render: aPresentation from: self! !

GLMPresentation subclass: #GLMRoassal2Presentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection newViewBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2Presentation commentStamp: '' prior: 0!
A GLMRoassalPresentation is xxxxxxxxx.

Instance Variables
	newViewBlock:		<Object>
	painting:		<Object>
	paintingBlock:		<Object>
	shouldPopulateSelection:		<Object>
	view:		<Object>

newViewBlock
	- xxxxx

painting
	- xxxxx

paintingBlock
	- xxxxx

shouldPopulateSelection
	- xxxxx

view
	- xxxxx
!

!GLMRoassal2Presentation methodsFor: 'scripting actions' stamp: 'akevalion 3/6/2017 19:39'!
act: aBlock entitled: aString categorized: anotherString help: anotherString2
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				help: anotherString2;
				yourself)! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'AlexandreBergel 10/24/2015 20:27'!
defaultActions
	GLMRoassal2Action initializePresentation: self! !

!GLMRoassal2Presentation methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 17:37'!
getContextFor: aView
	"Return the context associated to the view. It none is defined, then this method create one, and set it in view."
	| context |
	context :=  RTAbstractViewContext getContextFor: aView.
	context view: aView.
	context presentation: self. 
	^ context! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'TudorGirba 4/15/2014 07:39'!
initialize 
	super initialize.
	newViewBlock := [ RTView new ].
	shouldPopulateSelection := true.
	self defaultActions! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
initializeView: aZeroArgBlock
	^ newViewBlock := aZeroArgBlock ! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newView
	view := nil.
	^ self view! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newViewBlock
	^ newViewBlock! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'akevalion 7/14/2015 10:01'!
openIfPossible: fileName
	"
	By Sean
	
	Gofer it
	smalltalkhubUser: 'SeanDeNigris' project: 'SeansPlayground';
	package: 'NewExternalWebBrowser';
	load.

	'http://google.com' asUrl open.
	"
	
	#NewExternalWebBrowser asClassIfPresent: [ :cls | fileName asUrl open ].
	#NewExternalWebBrowser asClassIfAbsent: [ 
		self inform: 'Try to load NewExternalWebBrowser to fast open of this file' ].! !

!GLMRoassal2Presentation methodsFor: 'scripting' stamp: 'TudorGirba 2/13/2014 07:05'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
paintingBlock
	^ paintingBlock! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'TudorGirba 2/13/2014 07:17'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassal2Presentation: self! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'AlexandreBergel 11/12/2015 17:39'!
renderOn: aViewOrBuilder
	self paintingBlock
		glamourValue:
			aViewOrBuilder asGlamorousMultiValue , self entity asGlamorousMultiValue
				, self asGlamorousMultiValue.
	aViewOrBuilder build.
	self useContextToInitialize: aViewOrBuilder view.
	self view: aViewOrBuilder! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection
	^ shouldPopulateSelection! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:47'!
shouldPopulateSelection: aBoolean
	"Configure whether elements present in the view should be clickable or not"
	shouldPopulateSelection := aBoolean! !

!GLMRoassal2Presentation methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 17:37'!
useContextToInitialize: roassalView
	"Use the context of the view to initilize the view"
	| context |
	context := self getContextFor: roassalView.
	context adjustView: roassalView inPresentation: self! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view
	^ view ifNil: [ view := self newViewBlock value ]! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:45'!
view: aRTView
	view := aRTView! !

TestCase subclass: #GLMCameraCenterActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMCameraCenterActionTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/23/2015 19:07'!
testBasic

	| inst |
	inst := GLMCameraCenterAction new.
	inst roassalPresentation: GLMRoassal2Presentation new.
	inst execute! !

TestCase subclass: #GLMRoassal2ActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMRoassal2ActionTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/27/2015 11:54'!
testInitialize
	| prez nbActionOriginal |
	prez := GLMRoassal2Presentation new.
	nbActionOriginal := prez actions size.
	GLMRoassal2Action initializePresentation: prez.
	self assert: prez actions size - nbActionOriginal equals: GLMRoassal2Action allLeafSubclasses size.! !

!RTElement methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 11/30/2015 11:54'!
interestingToHave

"
From Andrei Chis:

spotterPreviewIn: aComposite
	<spotterPreview: 10>
	RTBlink unhighlightElements: self view elements.
	RTBlink highlight: self.
	aComposite addBrickBack: self view setUpCanvas buildMorph

"! !

!RTElement methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 11/30/2015 11:53'!
spotterActDefault
	"This method define the action when an element is selected in the spotter window"
	self view canvas camera translateTo: self position.
	RTBlink on: self.! !

!RTElement methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 11/30/2015 11:53'!
spotterPreviewIn: aComposite
	<spotterPreview: 10>
	RTBlink unhighlightElements: self view elements.
	RTBlink highlight: self.
	aComposite addBrickBack: self view setUpCanvas buildMorph! !

RTTest subclass: #RTGTContext
	instanceVariableNames: 'prez view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:48'!
setUp
	super setUp.
	prez := GLMRoassal2Presentation new.
	view := RTView new.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:48'!
testGetContextFor

	| context |
	self deny: view hasAttributes.
	context := prez getContextFor: view.
	self assert: context notNil.
	self assert: context class equals: RTAbstractViewContext defaultContextClass.
	self assert: (context class inheritsFrom: RTAbstractViewContext).
	self assert: view hasAttributes.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:49'!
testGetContextFor02

	| context |
	context := prez getContextFor: view.

	self assert: (RTAbstractViewContext getContextFor: view) equals: context.
	
	RTEmptyViewContext setOnView: view.	
	self assert: (RTAbstractViewContext getContextFor: view) ~~ context.
	self assert: (RTAbstractViewContext getContextFor: view) class equals: RTEmptyViewContext.! !

!RTGTContext methodsFor: 'removing context' stamp: 'AlexandreBergel 11/13/2015 18:54'!
testRemovingContext
	| c |
	self assert: view announcer numberOfSubscriptions equals: 0.
	RTInteractiveViewContext setOnView: view.
	self assert: view announcer numberOfSubscriptions equals: 0.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
	
	c := prez getContextFor: view.
	self assert: c class equals: RTInteractiveViewContext.
	c removeFromView.
	self assert: view announcer numberOfSubscriptions equals: 0.! !

!RTGTContext methodsFor: 'removing context' stamp: 'AlexandreBergel 11/13/2015 19:07'!
testRemovingContext02
	RTInteractiveViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
	"self assert: (view hasInteraction: RTSelectableElementContextInteraction)."
	self assert: (view hasInteraction: RTResizeableViewContextInteraction).

	RTEmptyViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 0.

	RTInteractiveViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/12/2015 16:53'!
testdefaultContextClass
	self assert: RTAbstractViewContext defaultContextClass notNil.
	self assert: RTAbstractViewContext defaultContextClass isBehavior.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:49'!
testuseContextToInitialize

	self assert: view announcer numberOfSubscriptions = 0.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions > 0! !

RTTest subclass: #RTGTContextInteractionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTGTContextInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/16/2015 13:31'!
testBasic

	| v int |
	v := RTView new.
	int := RTEmptyViewContextInteraction new.
	v @ int.
	self assert: (RTAbstractViewContext getContextFor: v) class equals: RTEmptyViewContext.! !

!RTGTContextInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/16/2015 13:32'!
testBasic02

	| v int |
	v := RTView new.
	int := RTResizeableViewContextInteraction new.
	v @ int.
	self assert: (RTAbstractViewContext getContextFor: v) class equals: RTInteractiveViewContext.! !

RTObject subclass: #GLMRoassal2Action
	instanceVariableNames: 'roassalPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

GLMRoassal2Action subclass: #GLMAbstractExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAbstractExportingAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ 'Export as...'! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:24'!
doExportToFull: fileName

	self subclassResponsibility! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'JurajKubelka 11/3/2015 18:44'!
execute
	| fileName |
	fileName := UITheme builder 
						fileSave: 'Enter the ', self titleExtension,' file name'
						extensions: self extensions
						path: nil.
	fileName notNil ifTrue: [ 
		self doExportToFull: fileName asAbsolute ]! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:22'!
extensions
	"
	May return for example: #('png')
	"
	^ #()! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:21'!
title
	^ 'Export to ', self titleExtension! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:21'!
titleExtension
	^ 'TOOVERRIDE'! !

GLMAbstractExportingAction subclass: #GLMHTMLExporting2Action
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:52'!
doExportToFull: fileName
	RTHTML5Exporter new 
		directory: fileName parent;
		fileName: fileName basename; 
		export: self roassalView.
! !

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:51'!
extensions
	^ #('html')! !

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:55'!
titleExtension
	^ 'HTML...'! !

GLMAbstractExportingAction subclass: #GLMHTMLExportingWithoutFixedShapesAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMHTMLExportingWithoutFixedShapesAction methodsFor: 'hooks' stamp: 'AlexandreBergel 3/29/2017 13:30'!
doExportToFull: fileName
	RTHTML5Exporter new 
		directory: fileName parent;
		fileName: fileName basename; 
		exportFixedShapes: false;
		export: self roassalView.
! !

!GLMHTMLExportingWithoutFixedShapesAction methodsFor: 'hooks' stamp: 'AlexandreBergel 3/29/2017 13:30'!
extensions
	^ #('html')! !

!GLMHTMLExportingWithoutFixedShapesAction methodsFor: 'hooks' stamp: 'AlexandreBergel 3/29/2017 13:30'!
titleExtension
	^ 'HTML (without fixed shapes)...'! !

GLMAbstractExportingAction subclass: #GLMPNGExporting2Action
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMPNGExporting2Action methodsFor: 'hooks' stamp: 'akevalion 2/20/2017 16:02'!
doExportToFull: fileName
	RTPNGExporter new
		withScale;
		builder: self roassalView;
		fileName: fileName fullName;
		exportToFile.! !

!GLMPNGExporting2Action methodsFor: 'hooks' stamp: 'akevalion 2/20/2017 15:21'!
extensions
	^ #('png')! !

!GLMPNGExporting2Action methodsFor: 'hooks' stamp: 'akevalion 2/20/2017 15:20'!
titleExtension
	^ 'PNG with scale'
	! !

GLMAbstractExportingAction subclass: #GLMPNGExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMPNGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:24'!
doExportToFull: fileName

	RTPNGExporter new 
				builder: self roassalView;
				fileName: fileName fullName;
				exportToFile.! !

!GLMPNGExportingAction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/23/2015 19:22'!
extensions
	^ #('png')! !

!GLMPNGExportingAction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/23/2015 19:21'!
titleExtension
	^ 'PNG'
	! !

GLMAbstractExportingAction subclass: #GLMSVGExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'JurajKubelka 11/3/2015 19:21'!
doExportToFull: fileName

	RTSVGExporter 
		exportBuilderAsSVG: self roassalView
		filename: fileName asAbsolute! !

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:25'!
extensions
	^ #('SVG')! !

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:25'!
titleExtension
	^ 'SVG'
	! !

GLMRoassal2Action subclass: #GLMAbstractSetContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAbstractSetContextAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:14'!
category
	^ 'Set context...'! !

!GLMAbstractSetContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:08'!
contextClass
	"Override to return the class to be considered"
	self subclassResponsibility! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 12/5/2015 10:41'!
execute
	"This method is executed by the menu offered by the Playground. Method #contextClass and #title have to be overriden"
"	self inform: self roassalPresentation hash asString."
	self contextClass setOnView: self roassalView.
	self roassalUpdate! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:09'!
order
	^ 50! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:09'!
title
	^ 'Set context ', self contextClass name! !

GLMAbstractSetContextAction subclass: #GLMEmptyContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMEmptyContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:09'!
contextClass
	^ RTEmptyViewContext! !

GLMAbstractSetContextAction subclass: #GLMInteractiveContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMInteractiveContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:09'!
contextClass
	^ RTInteractiveViewContext! !

GLMRoassal2Action subclass: #GLMAddLabelAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAddLabelAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ 'Interactions...'! !

!GLMAddLabelAction methodsFor: 'hooks' stamp: 'AlexandreBergel 2/24/2016 13:13'!
execute
	| msg lbl height |
	self roassalView when: TRMouseDoubleClick do: [ :evt |
		msg := UIManager default request: 'Enter a label'.
		(msg notEmpty and: [ msg ~= '' ]) ifTrue: [ 
			height := (self roassalView canvas camera distanceFromPixelToSpace: 20 @ 0) x.
			lbl := (RTLabel new height: height) elementOn: msg.
			self roassalView add: lbl.
			lbl @ RTDraggable.
			lbl translateTo: evt position.			
			self roassalUpdate
		]
	].
! !

!GLMAddLabelAction methodsFor: 'hooks' stamp: 'AlexandreBergel 2/24/2016 13:13'!
title
	^ 'Double click to add label'! !

GLMRoassal2Action subclass: #GLMAddScrollbarAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAddScrollbarAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ 'Interactions...'! !

!GLMAddScrollbarAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 17:43'!
execute
	self roassalView @ RTDoubleScrollBar.
	self roassalUpdate! !

!GLMAddScrollbarAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 17:43'!
title
	^ 'Add scrollbars'! !

GLMRoassal2Action subclass: #GLMBoxZoomAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMBoxZoomAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ 'Interactions...'! !

!GLMBoxZoomAction methodsFor: 'hooks' stamp: 'akevalion 12/4/2015 14:18'!
execute
	| int |
	int := RTZoomableBoxView new.
	self roassalView @ int.! !

!GLMBoxZoomAction methodsFor: 'hooks' stamp: 'akevalion 3/6/2017 19:19'!
title
	^ 'Add RTZoomableBoxView'! !

GLMRoassal2Action subclass: #GLMCameraCenterAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:58'!
execute
	self trachelCanvas focusOnCenterScaled.
	self roassalUpdate! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:59'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomToFit! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 11:56'!
order
	^ 6! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:59'!
title
	^ 'Camera center'! !

GLMRoassal2Action subclass: #GLMFindInViewAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:11'!
execute
	GTSpotterMorph new
          extent: 400@500;
          spotterModel: (GTSpotter on: self roassalView);
          openCenteredInWorld! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:09'!
icon
	^ GLMUIThemeExtraIcons glamorousInspect! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:09'!
order
	^ 50! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:10'!
title
	^ 'Find'! !

GLMRoassal2Action subclass: #GLMHTMLExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMHTMLExportingAction methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ 'Export as...'! !

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/6/2016 14:38'!
execute
	| fileName |
	fileName := (RTHTML5Exporter new export: self roassalView) asUrl.
	"self openIfPossible: fileName."! !

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:47'!
openIfPossible: fileName
	"
	By Sean
	
	Gofer it
	smalltalkhubUser: 'SeanDeNigris' project: 'SeansPlayground';
	package: 'NewExternalWebBrowser';
	load.

	'http://google.com' asUrl open.
	"
	
	#NewExternalWebBrowser asClassIfPresent: [ :cls | fileName asUrl open ].
	#NewExternalWebBrowser asClassIfAbsent: [ 
		self inform: 'Try to load NewExternalWebBrowser to fast open of this file' ].! !

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:45'!
title
	^ 'Export to HTML'! !

GLMRoassal2Action subclass: #GLMInspectViewAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMInspectViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:53'!
execute
	self roassalView inspect! !

!GLMInspectViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:53'!
title
	^ 'Inspect View'! !

!GLMRoassal2Action class methodsFor: 'initialization' stamp: 'AlexandreBergel 10/24/2015 19:40'!
allLeafSubclasses
	^ self allSubclasses select: #isLeaf! !

!GLMRoassal2Action class methodsFor: 'initialization' stamp: 'akevalion 3/6/2017 21:19'!
initializePresentation: aRoassal2Presentation
	| instances orderedInstances |
	instances := self allLeafSubclasses collect: #new.
	orderedInstances := instances sortedAs: #order.
	orderedInstances do: [ :inst | 
		inst icon notNil
			ifTrue: [ aRoassal2Presentation
				act: [ :r | inst executeOn: r ]
				icon: inst icon
				entitled: inst title ]
			ifFalse: [ aRoassal2Presentation
				act: [ :r | inst executeOn: r ]
				entitled: inst title
				categorized: inst category ] ]! !

!GLMRoassal2Action class methodsFor: 'testing' stamp: 'AlexandreBergel 10/24/2015 19:39'!
isLeaf
	^ self subclasses size = 0! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:13'!
category
	^ nil! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'TudorGirba 4/28/2016 15:42'!
execute
	"Override please"
	self subclassResponsibility! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'TudorGirba 4/28/2016 15:47'!
executeOn: aPresentation
	self roassalPresentation: aPresentation.
	self execute! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:53'!
icon
	"Override please"
	^ nil! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 10! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:52'!
roassalPresentation
	^ roassalPresentation! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:52'!
roassalPresentation: anObject
	roassalPresentation := anObject! !

!GLMRoassal2Action methodsFor: 'do' stamp: 'AlexandreBergel 10/23/2015 19:08'!
roassalUpdate
	self roassalView signalUpdate ! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:55'!
roassalView
	"Return the roassal view. Handy to be used in the actions"
	^ self roassalPresentation view view! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:53'!
title
	"Override please"
	^ 'Unamed'! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:58'!
trachelCanvas
	^ self roassalView canvas! !

GLMRoassal2Action subclass: #GLMSelectionBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMSelectionBox methodsFor: 'accessing' stamp: 'akevalion 3/6/2017 19:18'!
category
	^ 'Interactions...'! !

!GLMSelectionBox methodsFor: 'hooks' stamp: 'akevalion 3/6/2017 19:19'!
execute
	| int |
	int := RTSelectionBox new.
	self roassalView @ int.! !

!GLMSelectionBox methodsFor: 'hooks' stamp: 'akevalion 3/6/2017 19:19'!
title
	^ 'Add RTSelectionBox'! !

GLMRoassal2Action subclass: #GLMZoomInAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMZoomInAction methodsFor: 'hooks' stamp: 'TudorGirba 4/28/2016 14:34'!
execute
	RTZoomInMove on: self roassalView! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomIn! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 1! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
title
	^ 'Zoom in'! !

GLMRoassal2Action subclass: #GLMZoomOutAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:58'!
execute
	RTZoomOutMove on: self roassalView! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:10'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomOut! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 5! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
title
	^ 'Zoom in'! !

RTObject subclass: #RTAbstractViewContext
	instanceVariableNames: 'view presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTAbstractViewContext class methodsFor: 'private - utility' stamp: 'AlexandreBergel 11/12/2015 17:36'!
createContext
	"Define a new context in case none has been set"
	^ self defaultContextClass new! !

!RTAbstractViewContext class methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 16:52'!
defaultContextClass
	"Return the default context used by Glamour when no context is set"
	^ self withAllSubclasses detect: #isDefault! !

!RTAbstractViewContext class methodsFor: 'private - utility' stamp: 'AlexandreBergel 11/12/2015 17:36'!
getContextFor: aView
	"Return the context associated to the view. It none is defined, then this method create one, and set it in view."
	^ aView attributeAt: #GlamourContext ifAbsentPut: [ self createContext ].
! !

!RTAbstractViewContext class methodsFor: 'testing' stamp: 'AlexandreBergel 11/12/2015 16:52'!
isDefault
	^ false! !

!RTAbstractViewContext class methodsFor: 'public' stamp: 'AlexandreBergel 11/16/2015 13:28'!
setOnView: aView
	"Set the context on the view"
	(aView hasAttribute: #GlamourContext) ifTrue: [ 
		(aView attributeAt: #GlamourContext) unregisterPreviousContext
	].
	aView attributeAt: #GlamourContext put: self new! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 19:08'!
adjustView: aView inPresentation: aPresentation.
	self view: aView.
	self presentation: aPresentation.
	self registerCallbacks! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 15:52'!
canvas
	^ view canvas! !

!RTAbstractViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:42'!
interactionsToBeRegistered
	"Override to return a list of classes that have be to registered"
	self subclassResponsibility! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 17:28'!
presentation
	"Return the Roassal2Presentation in which I am used"
	^ presentation! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 16:40'!
presentation: aPresentation
	self assert: [ aPresentation isKindOf: GLMRoassal2Presentation ] description: 'Only a GLMRoassal2Presentation can be provided here'.
	presentation := aPresentation! !

!RTAbstractViewContext methodsFor: 'documentation' stamp: 'AlexandreBergel 7/3/2016 16:39'!
readme
"
RTAbstractViewContext is the root class of the view contexts. A view context bridges Roassal with GT. 
You need to create a subclass of RTAbstractViewContext if you want to define a particular operation involving GT 

"! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 18:45'!
registerCallbacks
	"Register the different interactions on the view"
	self interactionsToBeRegistered 
		do: [ :intClass | self view @ (intClass new presentation: self presentation) ]! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 18:54'!
removeFromView
	"Remove the context from the view. All the callbacks due to the interaction are removed as well"
	self view removeAttributeAt: #GlamourContext ifAbsent: [ ].

	self interactionsToBeRegistered do: [ :intClass | 
		self view removeInteractionIfPresent: intClass ]! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 12/5/2015 10:43'!
unregisterPreviousContext
	self view ifNil: [ ^ self ].
	(self class getContextFor: self view) removeFromView! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 15:52'!
view
	^ view! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:55'!
view: aView
	"Set the view in the context"
	self assert: [ aView isKindOf: RTView ] description: 'Only a roassal view may be provided'.
	view := aView! !

RTAbstractViewContext subclass: #RTEmptyViewContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTEmptyViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:42'!
interactionsToBeRegistered
	^ #()! !

RTAbstractViewContext subclass: #RTGrapherSelectRangeViewContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTGrapherSelectRangeViewContext commentStamp: 'AlexandreBergel 7/4/2016 18:31' prior: 0!
Define a range for GT

-=-=-=
g := RTGrapher new.
g view: RTView new.
ds := RTData new.
ds dotShape color: Color blue trans.
ds points: RTShape withAllSubclasses.
ds y: [ :cls | cls numberOfMethods - 50 ].
ds x: [ :cls | cls numberOfLinesOfCode - 150 ].
g add: ds.

RTGrapherSelectRangeViewContext onGrapher: g callback: [ :elements |  (g view attributeAt: #presentation) selection: elements ].

g 
-=-=-=
!

!RTGrapherSelectRangeViewContext class methodsFor: 'public' stamp: 'AlexandreBergel 7/3/2016 17:39'!
onGrapher: aGrapher

	"We need to make sure that the view knows about the grapher"
	aGrapher view attributeAt: #grapher put: aGrapher.
	aGrapher addDecorator: (RTRangeSelector new)! !

!RTGrapherSelectRangeViewContext class methodsFor: 'public' stamp: 'AlexandreBergel 7/3/2016 18:22'!
onGrapher: aGrapher callback: aOneArgBlock
	self setOnView: aGrapher view.
	"We need to make sure that the view knows about the grapher"
	aGrapher view attributeAt: #grapher put: aGrapher.
	aGrapher addDecorator: (RTRangeSelector new callback: aOneArgBlock)! !

!RTGrapherSelectRangeViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 7/18/2016 10:56'!
interactionsToBeRegistered
	^ Array with: RTGrapherSelectRangeContextInteraction with: RTResizeableViewContextInteraction "with: RTSelectableElementsContextInteraction" ! !

RTAbstractViewContext subclass: #RTInteractiveViewContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTInteractiveViewContext class methodsFor: 'testing' stamp: 'AlexandreBergel 11/12/2015 16:52'!
isDefault
	^ true! !

!RTInteractiveViewContext methodsFor: 'hooks' stamp: 'PeterUhnak 8/4/2016 09:43'!
interactionsToBeRegistered
	^ Array with: RTSelectableElementsContextInteraction with: RTResizeableViewContextInteraction! !

RTObject subclass: #RTEventRegister
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-EventCollector'!

!RTEventRegister class methodsFor: 'class initialization' stamp: 'AlexandreBergel 11/17/2015 11:54'!
initialize
	"
	self initialize
	"
	| collector |
	collector := GTEventCollector new.
	collector occupant: self; category: 'roassal2Examples'; register.
	RTAbstractExample announcer when: RTExampleOpeningEvent do: [ :evt |
		collector add: evt
	] ! !

RTEventRegister initialize!

!RTObject class methodsFor: '*Roassal2GT-Examples' stamp: 'StefanReichhart 7/21/2016 17:45'!
gtExamplesFactory
	^ RTExampleFactory new
		source: self;
		yourself! !

!RTBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleBuilder
	<gtExample>
	<label: 'Example builder'>
	
	^ self new! !

!RTBuilder methodsFor: '*Roassal2GT-Inspector' stamp: 'TudorGirba 10/5/2014 12:16'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!RTBuilder methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 12/15/2015 13:54'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal';
		with: [:composite |
			composite roassal2 title: 'Painting'; initializeView: [ self ] ];
		openOn: self! !

!RTBuilder methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/5/2014 12:16'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!RTView class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleEmptyView
	<gtExample>
	<label: 'Empty view'>
	
	^ self new! !

!RTView methodsFor: '*Roassal2GT-Inspector' stamp: 'TudorGirba 11/1/2014 23:12'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite table 
		title: 'Elements';
		showOnly: 50;
		display: [ :each | each elements ];
		children: #nestedElements;
		column: 'Model' evaluated: [ :each | each model asString ];
		column: 'Shape' evaluated: [ :each | each shape asString ]! !

!RTView methodsFor: '*Roassal2GT-Inspector' stamp: 'AlexandreBergel 3/31/2014 14:24'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]
		! !

!RTView methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 12/15/2015 13:53'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal';
		with: [:composite | composite roassal2 title: 'Painting'; initializeView: [self ] ];
		openOn: self! !

!RTView methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/7/2014 07:38'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!RTView methodsFor: '*Roassal2GT-Spotter' stamp: 'AndreiChis 7/12/2015 00:10'!
spotterPreviewIn: aComposite
	<spotterPreview: 10>
	
	self build.
	aComposite addBrickBack: self view setUpCanvas buildMorph

	! !

!RTView methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 4/14/2017 18:59'!
spotterShapesFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor
		title: 'Shapes';
		candidatesLimit: 5;
		allCandidates: [ self elements asOrderedCollection ];
		itemName: [ :each | 
			each gtDisplayString, 
			' [', each shape class name, '] - ', 
			each model gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!RTView methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 4/14/2017 18:59'!
spotterShapesModelsFor: aStep
	<spotterOrder: 15>
	^ aStep listProcessor
		title: 'Model objects';
		candidatesLimit: 5;
		allCandidates: [ ((self elements collectAsSet: #model) reject: #isNil) asOrderedCollection ];
		itemName: [ :each | each gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!TRCanvas class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty canvas'>
	
	^ TRCanvas new! !

!TRCanvas methodsFor: '*Roassal2GT-Inspector' stamp: 'AlexandreBergel 9/8/2014 11:41'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'Canvas';
		initializeView: [ RTView new setCanvas: self ]
		! !

GTExampleFactory subclass: #RTExampleFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Examples'!

!RTExampleFactory methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 7/2/2016 19:54'!
defaultExampleClass
	^ RTExampleSelection! !

!RTExampleFactory methodsFor: 'private - creating examples' stamp: 'StefanReichhart 7/19/2016 13:53'!
initializeExample: aGTExample fromMethod: aCompiledMethod
	super initializeExample: aGTExample fromMethod: aCompiledMethod.
	
	self initializeIconFromMethod: aCompiledMethod forExample: aGTExample.
! !

!RTExampleFactory methodsFor: 'private - creating examples' stamp: 'StefanReichhart 4/14/2017 09:40'!
initializeIconFromMethod: aCompiledMethod forExample: aGTExample
	aGTExample icon ifNotNil: [ ^ self ].

	[ aGTExample form: (aGTExample methodResolverClass resolve: RTExampleMethodIcon example: self className: aCompiledMethod methodClass meta: aCompiledMethod methodClass isMeta selector: aCompiledMethod selector)  ]
		on: Error
		do: [ :exception | 
			aGTExample addProblem: (GTExampleError new 
				example: aGTExample;
				signaledException: exception;
				yourself) ]! !

!RTExampleFactory methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:55'!
isExampleMethod: aCompiledMethod
	^ (super isExampleMethod: aCompiledMethod)
		or: [ self isOldStyleRTExampleMethod: aCompiledMethod ]! !

!RTExampleFactory methodsFor: 'testing' stamp: 'StefanReichhart 7/2/2016 20:01'!
isOldStyleRTExampleMethod: aCompiledMethod
	^ (aCompiledMethod selector beginsWith: 'example')
		and: [ (aCompiledMethod selector endsWith: 'Icon') not ]! !

!RTAbstractExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'AndreiChis 1/14/2015 15:39'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	<gtInspectorTag: #examples>
	^ self new gtInspectorPreviewIn: composite! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'AndreiChis 10/30/2014 14:40'!
gtDisplayExamplesIn: aComposite

	^ (self gtInspectorPreviewIn: aComposite)
		title: 'E.g'! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/9/2015 09:10'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	^ composite roassal2
		title: 'Examples';
		when: [ self gtExamples notEmpty ];
		send: [ :example | example ];
		painting: [ :view | 
			view @ RTDraggableView.
			self gtOpenOn: view ]! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'PeterUhnak 8/12/2016 14:23'!
gtOpenOn: v
	| icon64Mime form element |
	(self gtExamples
		sorted: [ :a :b | a method selector asLowercase < b method selector asLowercase ])
		do: [ :anExample | 
			[ icon64Mime := self perform: (anExample method selector , #Icon) asSymbol.
			form := TRPlatform current formClass
				fromBinaryStream: (TRPlatform current mimeDecodeToBytes: icon64Mime readStream) ]
				on: Error
				do: [ :exception |  ].	" ignore, continue and use a fallback form "
			form ifNil: [ form := Color red iconOrThumbnailOfSize: 32 ].
			" not all examples stick to the naming convention or simply dont provide an icon, provide a fallback here since RTExampleBrowser is the only entity that depends strongly on icons "
			element := (RTBitmap new form: form) elementOn: anExample.
			element @ (RTPopup new text: anExample method selector asString).
			element @ (RTEventForwarder new eventClass: TRMouseDragging).
			element
				when: TRMouseClick
				do: [ :event | 
					self announcer
						announce:
							(RTExampleOpeningEvent new
								theClass: self className;
								theSelector: anExample method selector) ].
			v add: element ].
	RTGridLayout new
		gapSize: 50;
		on: v elements.
	v elements
		@
			(RTLabeled new
				below;
				fontSize: 10;
				text: [ :m | m method selector asString withoutPrefix: 'example' ])! !

GTExample subclass: #RTExampleSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Examples'!

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleAtRandom
	<gtExample>
	<label: 'Random example'>
	
	^ RTAbstractExample subclasses atRandom new gtExamples atRandom! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 20:56'!
gtExampleFlags1
	<gtExample>
	<label: 'Example flags 1'>
	
	^ RTComposedShapeExample gtExamples
		detect: [ :example | example method selector = #exampleFlags ]
		ifNone: [ nil ]! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 23:40'!
gtExampleFlags2
	<gtExample>
	<label: 'Example flags 2'>
	
	^ (RTComposedShapeExample >> #exampleFlags) gtExamples first! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 23:40'!
gtExampleFlags3
	<gtExample>
	<label: 'Example flags 3'>
	
	^ (RTComposedShapeExample >> #exampleFlags) gtExample! !

!RTExampleSelection methodsFor: 'inspector extensions' stamp: 'AlexandreBergel 12/13/2016 08:59'!
gtDebuggerSourceIn: composite
	"Cancel the method"
	<gtDebuggerPresentationOrder: 1>! !

!RTExampleSelection methodsFor: 'ui' stamp: 'StefanReichhart 11/20/2015 18:10'!
gtDisplayPlaygroundIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite pharoScript
		title: 'Playground';
		format: [ self playgroundSourceCode ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text evaluateSelectionAndDo: [ :anObject | text selection: anObject ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
			on: $g
			entitled: 'Do it all and go (g)'
		! !

!RTExampleSelection methodsFor: 'inspector extensions' stamp: 'AlexandreBergel 4/11/2017 08:54'!
gtInspectorMetaIn: composite
	"Cancel the method"
	<gtDebuggerPresentationOrder: 1>! !

!RTExampleSelection methodsFor: 'inspector extensions' stamp: 'AlexandreBergel 4/11/2017 08:50'!
gtInspectorMethodIn: composite
	"Cancelling method"! !

!RTExampleSelection methodsFor: 'ui' stamp: 'StefanReichhart 11/19/2015 20:51'!
gtInspectorRoassalViewIn: composite
	<gtInspectorPresentationOrder: -10>
	| returnValue |
	returnValue := self returnValue. " rt examples are no longer cached - we make a speed bump here "
	((Array with: RTView with: RTBuilder) noneSatisfy: [ :c | returnValue class includesBehavior: c ])
		ifTrue: [ ^ self ].
	composite roassal2
		title: 'Canvas';
		initializeView: [ returnValue ]
		! !

!RTExampleSelection methodsFor: 'inspector extensions' stamp: 'AlexandreBergel 4/11/2017 08:51'!
gtInspectorSourceIn: composite
	"Cancel the method"
	<gtDebuggerPresentationOrder: 1>! !

!RTExampleSelection methodsFor: 'ui' stamp: 'StefanReichhart 9/9/2015 20:13'!
gtInspectorViewIn: composite
	self deprecated: 'Please use #gtInspectorRoassalViewIn: instead'.
	^ self gtInspectorRoassalViewIn: composite! !

!RTExampleSelection methodsFor: 'inspector extensions' stamp: 'StefanReichhart 11/20/2015 18:09'!
gtSpotterPreviewIconIn: aComposite
	<spotterPreview: 10>
	(self icon notNil or: [ self provider class canPerform: (self selector, 'Icon') asSymbol ])
		ifTrue: [ 
			aComposite addBrickBack: (self icon asAlphaImageMorph
				layout: #center;
				scale: 2.0) asBrick ]

	! !

!RTExampleSelection methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 18:36'!
matchesQuery: aSetOfNames
	| sourceCode |
	
	sourceCode := self method sourceCode asLowercase.
	^ aSetOfNames allSatisfy: [ :each | sourceCode includesSubstring: each ]
! !

!RTExampleSelection methodsFor: 'public' stamp: 'StefanReichhart 11/20/2015 18:24'!
playgroundSourceCode 
	" this is really ugly - we would like to perfectly preserve the original format including comments BUT with pragmas stripped - is there a better way ? original code below "
	^ self method parseTree body formattedCodeWithMaxLineLength: 999
	"
	| sourceCode firstLine sourceCodeWithoutFirstLine |
	sourceCode := self method sourceCode.
	firstLine := sourceCode lines first.
	sourceCodeWithoutFirstLine := sourceCode copyFrom: firstLine size + 1 to: sourceCode size.
	^ sourceCodeWithoutFirstLine 
	"! !

RTInteraction subclass: #RTAbstractContextInteraction
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTAbstractContextInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:34'!
presentation
	^ presentation! !

!RTAbstractContextInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:35'!
presentation: aGLRoassalPresentation
	presentation := aGLRoassalPresentation! !

RTAbstractContextInteraction subclass: #RTEmptyViewContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTEmptyViewContextInteraction commentStamp: 'AlexandreBergel 11/16/2015 13:35' prior: 0!
Interaction for a view. Make the view __not__ resizeable in GTInspector. Here is an example:
-=-=-=
b := RTMondrian new.
b nodes: (1 to: 100).
b layout grid.
b view @ RTEmptyViewContextInteraction.
b
-=-=-=!

!RTEmptyViewContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/16/2015 13:28'!
initializeElement: aView
	RTEmptyViewContext setOnView: aView ! !

RTAbstractContextInteraction subclass: #RTGrapherSelectRangeContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTGrapherSelectRangeContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 7/4/2016 18:28'!
initializeElement: aView
	"This expression is executed after the GTInspector window is open. So, after the build has been done."
	self assert: [ self presentation notNil ] description: 'The presentation has to be set'.
	aView attributeAt: #presentation put: self presentation
! !

RTAbstractContextInteraction subclass: #RTResizeableViewContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTResizeableViewContextInteraction commentStamp: 'AlexandreBergel 11/16/2015 13:35' prior: 0!
Interaction for a view. Make the view resizeable in GTInspector. Here is an example:
-=-=-=
b := RTMondrian new.
b nodes: (1 to: 100).
b layout grid.
b view @ RTResizeableViewContextInteraction.
b
-=-=-=!

!RTResizeableViewContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/16/2015 13:32'!
initializeElement: aView
	"self assert: [ self presentation notNil ] description: 'The presentation has to be set'."

	aView canvas
		when: TRResizeCanvasEvent
		do: [ :evt | 
			| es |
			es := aView elements asGroup encompassingRectangle. 
			(es width + es height) > 4000
				ifFalse: [ aView canvas focusOnCenterScaled ] ]! !

RTAbstractContextInteraction subclass: #RTSelectableElementContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTSelectableElementContextInteraction commentStamp: 'AlexandreBergel 12/1/2015 14:34' prior: 0!
This is an interaction for an element

!

!RTSelectableElementContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 12/1/2015 14:34'!
initializeElement: anElement
	self assert: [ self presentation notNil ] description: 'The presentation has to be set'.
	
	anElement when: TRMouseLeftClick do: [ :event | 
			anElement model ifNotNil: [ self presentation selection: anElement model ] ]! !

RTAbstractContextInteraction subclass: #RTSelectableElementsContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTSelectableElementsContextInteraction commentStamp: 'AlexandreBergel 12/1/2015 14:34' prior: 0!
This is an interaction for a view!

!RTSelectableElementsContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2017 11:27'!
initializeElement: aView
	self
		assert: [ self presentation notNil ]
		description: 'The presentation has to be set'.
	self initializeSetOfElements: aView elements! !

!RTSelectableElementsContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2017 11:27'!
initializeSetOfElements: elements
 	elements do:
		[ :each | self initializeSingleElement: each ]! !

!RTSelectableElementsContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2017 11:24'!
initializeSingleElement: each
	^ each
		when: TRMouseLeftClick
		do:
			[ :event | each model ifNotNil: [ self presentation selection: each model ] ]! !

RTInteraction subclass: #RTFindInAView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Spotter'!

!RTFindInAView methodsFor: 'hooks' stamp: 'AliakseiSyrel 1/19/2015 21:36'!
initializeElement: aView

	| mb |
	mb := RTMenuBuilder new.
	mb view: aView.
	mb menu: 'Find' callback: [ 
        GTSpotterMorph new
                        extent: 400@500;
                        spotterModel: (GTSpotter on: aView);
                        openCenteredInWorld ].
	mb build! !

GTExampleTestCase subclass: #RTExampleTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Tests-Examples'!

!RTExampleTestCase methodsFor: 'configuration' stamp: 'StefanReichhart 11/28/2015 16:54'!
packageNames
	^ { 'Roassal2' . 'Roassal2GT' }! !

GTAbstractExampleMethod subclass: #RTExampleMethodIcon
	uses: TGTExampleIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Examples'!

RTExampleMethodIcon class
	uses: TGTExampleIcon classTrait
	instanceVariableNames: ''!

!RTExampleMethodIcon methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 14:01'!
basicForm
	| iconSelector iconProvider icon64Mime |
	iconSelector := (self selector, 'Icon') asSymbol.
	((iconProvider := self provider) class canPerform: iconSelector) ifFalse: [ ^ nil ].
	icon64Mime := [ iconProvider perform: iconSelector ]
		on: Error
		do: [ ^ nil ].
	^ [ TRPlatform current formClass fromBinaryStream: 
			(TRPlatform current mimeDecodeToBytes: icon64Mime readStream) ]
		on: Error
		do: [ nil ]! !

!RTExampleMethodIcon methodsFor: 'testing' stamp: 'StefanReichhart 7/19/2016 14:02'!
exists
	^ super exists
		and: [ self methodClass includesSelector: (self selector, 'Icon') asSymbol ]! !

RTEventRegister initialize!
